package BattagliaNavale;

public class Cella {

	private int x, y;
	
	public Cella(int xx, int yy) {
		if (xx < 0 || xx >= Parametri.N) throw new IllegalArgumentException("La coordinata x deve essere tra 0 e " + (Parametri.N-1) );
		if (yy < 0 || yy >= Parametri.N) throw new IllegalArgumentException("La coordinata y deve essere tra 0 e " + (Parametri.N-1));	
		
		x = xx; 
		y = yy;
	}

	public int getX() { return x; }
	public int getY() { return y; }
	
	public boolean equals(Object o) {
		if(o == null) return false;
		if (! this.getClass().equals(o.getClass()) ) return false;
		return x == ((Cella)o).x && y == ((Cella)o).y;
	}
	public int hashCode() {
		return x*y;
	}

	public String toString() {
		return "(" + x + "," + y + ")";
	}

}