package BattagliaNavale;

import java.util.*;

public abstract class Giocatore {
	private String nome;

	public final static int MAX_TENTATIVI = 10;	

	private List<Nave> navi = new ArrayList<Nave>();
	
	public Giocatore(String n) {
		nome = n;
		// popola array navi 
		for (int i=0; i<Parametri.quanteNavi.length; i++) {
			for (int j=0; j<Parametri.quanteNavi[i]; j++) {
				navi.add(  new Nave( Parametri.lunghezzaNavi[i] ) );
			}
		}
	}

	
	public abstract void disponi();


	public void stampaCampo() {
		int lungCella = ("" + (navi.size()-1)).length();
		
		String campo[][] = new String[Parametri.N][Parametri.N];
		for (int x=0; x<Parametri.N; x++) {
			for(int y=0; y<Parametri.N; y++) {
				campo[x][y] = "";
				for (int k=0; k<lungCella; k++) campo[x][y] += "~";
			}
		}
		
		int intN=1;
		for (Nave n : navi) {
			System.out.println("Colloco la nave " + intN + " lunga " + n.getLung());
			if (n.isVersoEst()) {
				for(int k=n.getInizio().getX(); k<=n.getInizio().getX()+n.getLung()-1; k++) {
					campo[k][n.getInizio().getY()] = ""+intN;
				}
			} else {
				for(int k=n.getInizio().getY(); k<=n.getInizio().getY()+n.getLung()-1; k++) {
					campo[n.getInizio().getX()][k] = ""+intN;
				}	
			}			
			intN++;			
		}
		
		
		for (int x=0; x<Parametri.N; x++) {
			for (int y=0; y<Parametri.N; y++) {		
				int quantiSpazi = lungCella - campo[x][y].length();
				String testoCella = "";
				for (int k=0; k<quantiSpazi; k++) testoCella += " ";
				testoCella += campo[x][y];
				
				System.out.print( testoCella + "  " );
			}
			System.out.println();
		}
		


	}


}
