package BattagliaNavale;

public class GiocatoreComputer extends Giocatore {

	public GiocatoreComputer(String n) { 
		super(n); 
		disponi();
	}
	
	public void disponi() {
		boolean tutteLeNaviDisposteCorrettamente = false;
		Random random = new Random();		
		for (int i=0; i<MAX_TENTATIVI && !tutteLeNaviDisposteCorrettamente; i++) {
			System.out.println("\n\nDispongo tutte le navi - tentativo " + i);
		/*	per ogni nave, indovina in modo random la sua posizione e il suo verso
			se NON ci sono sovrapposizioni, esci
		}
		SE CI SONO ancora sovrapposizione, genera eccezione "non ci sono riuscito!";
		
		Random random = new Random();
		
		random.nextInt(n):  restituisce un int tra 0 e n-1 (n e' escluso!)
		random.nextBoolean():  restuisce un boolean random (true o false)
		*/


			int nInt = 0;
			for (Nave n : navi) {
				System.out.println("Dispongo la nave " + nInt + " lunga " + n.getLung());
				boolean disposizioneNaveNTrovata = false;
				for(int t=0;   t<MAX_TENTATIVI && !disposizioneNaveNTrovata;   t++) {
					System.out.print("   Tentativo " + t + "...");
					Cella inizio = 
						new Cella( 	random.nextInt( Parametri.N ) , 
									random.nextInt( Parametri.N )
						);
					boolean versoEst = random.nextBoolean();	
					System.out.print(inizio + " verso " + (versoEst?"est":"sud") + "...");					
					try {
						n.disponi(inizio, versoEst);
						System.out.println("ok");
						disposizioneNaveNTrovata = true;
					} catch(IllegalArgumentException e) {
						// non faccio nulla
						System.out.println("ops! fuori dal campo");
					}
				}
				nInt++;
			} // Tutte le navi sono disposte
			
			if ( !ciSonoSovrapposizioni()) {
				tutteLeNaviDisposteCorrettamente = true;
			}
		}
		if (!tutteLeNaviDisposteCorrettamente) throw new Error();
		
		/*
			Esercizio: invece di controllare la presenza di sovrapposizioni dopo 
			aver disposto TUTTE le navi, un modo piu' efficiente di procedere e' di
			verificare, dopo ogni inserimento, se la relativa nave "n_i" comporta
			sovrapposizioni.
			Si noti che, in questo caso, durante il tentativo di posizionare la nave n_i 
			E' GARANTITO che non ci sono sovrapposizioni tra le navi n_1, n_2, ..., n_(i-1).
			
			Se il posizionamento della nave n_i comporta sovrapposizioni, si possono effettuare altri tentativi (ad es. MAX_TENTATIVI), riposizionando esclusivamente
			n_i. Se, dopo MAX_TENTATIVI tentativi il posizionamento di n_i ancora comporta 
			sovrapposizioni, si puo' procedere a riposizionare una nave gia' posizionata, ad 
			es. quella "precedente", cioe' n_(i-1), oppure una tra quelle con cui n_i si 
			sovrappone.	
			Provare come, al crescere della densita' di celle occupate del campo di battaglia
			tale strategia e' molto piu' efficiente ed efficace.
			
			Esistono strategie migliori, ma piu' complicate, per la disposizione
			randomica delle navi evitando sovrapposizioni, che non vedremo.
			
			
			Inoltre, si puo' evitare di generare posizioni per una nave, che la collochino
			fuori dal campo. Modificare il codice per fare in modo che il metodo 
			Nave.disponi() non generi mai un'eccezione (suggerimento: prima generare 
			in modo random il verso, ed in base a questo e alla lunghezza della nave in
			questione, ridurre quanto basta il valore
			massimo per le coordinate (X o Y, in dipendenza dal verso) "legali" (argomento di
			Random.nextInt()). As es., durante la disposizione di una nave lunga 5, 
			se il verso e' "est", allora la coordinata X della cella d'inizio non puo' essere
			maggiore di N-5.
		*/		
		
	}


	private boolean ciSonoSovrapposizioni()	{
		for(int n1 = 0; n1 < navi.size()-1 ; n1++) {
			Nave nave1 = navi.get(n1);
			
			for (int n2 = n1+1;  n2 < navi.size(); n2++) {
				Nave nave2 = navi.get(n2);
			
				if (nave1.siSovrapponeA(nave2)) {
					System.out.println("La nave " + n2 + " si sovrappone a " + n1);
					return true;
				}
			}
		}
		return false;	
	}
	

}
