package BattagliaNavale;

public class Nave {

	private Cella inizio;
	private boolean versoEst;
	private int lung;

	public Nave(int l) {
		if (l <= 0) throw new IllegalArgumentException("La lunghezza deve essere > 0");
		lung = l;
		inizio = null;
	}
	
	public boolean isDisposta() {
		return (inizio != null);
	}
	
	public Cella getInizio() { return inizio; }
	public boolean isVersoEst() { return versoEst; }
	public int getLung() { return lung; }
	
	public void disponi(Cella in, boolean est) {
		if (est) {
			if (in.getX() + this.lung-1 >= Parametri.N)
				throw new IllegalArgumentException("...");
		} else {
			if (in.getY() + this.lung-1 >= Parametri.N)
				throw new IllegalArgumentException("...");
		}		
		this.inizio = in;
		this.versoEst = est;
	}
	
	
	public boolean occupaCella(Cella c) {
		if (!this.isDisposta()) return false;
	
		Cella cn = this.inizio;
		
		if(this.versoEst) {
			return c.getY() == this.inizio.getY() && 
					c.getX() >= this.inizio.getX() &&
					c.getX()-this.inizio.getX() < this.lung;
		} else {
			return c.getX() == this.inizio.getX() && 
					c.getY() >= this.inizio.getY() &&
					c.getY()-this.inizio.getY() < this.lung;
		}
	
	}
	
	public boolean siSovrapponeA(Nave n) {
		if (!n.isDisposta()) return false;		
		if (!this.isDisposta()) return false;				
		Cella c = n.inizio;
		for (int volte = 0; volte < n.lung; volte++) {
			if (this.occupaCella(c)) return true;
			
			if (volte < n.lung-1) {
				//c = "cella successiva";
				if (n.versoEst) {
					c  = new Cella( c.getX() + 1, c.getY() );
				} else {
					c  = new Cella( c.getX(), c.getY()+1 );
				}
			}
		}		
		return false;
	}	

}